#!/bin/bash
###############################################################
################## v2/v3 scanner ##############################
# a little bash script to scan the darkweb for tor addresses
# adjust the proxy variables in /etc/lynx/lynx.cfg if needed
# than just call the script from a subdir, and let run
# you will need a file called "links.txt" containing onion
# links to start the script of (there are some popular 
# addresses preloaded).
# the script runs in an endless loop until there are no more
# links to be followed. you can stop anytime with CTRL+C
# without loosing anything but the currently
# running request. Another start of the script, and it will
# pickup where it was interrupted. all of this is
# EXPERIMENTAL CODE, USE AT OWN RISK
###############################################################
counter=0
touch ./visited_links.txt
while true
do
	counter=$(("$counter"+1))
	sort -u links.txt | grep -E 'http:\/\/[[:alnum:]]{16,56}\.onion.*' | sort > links_new.txt && mv links_new.txt links.txt
	visited_link_count=$(wc -l visited_links.txt | cut -f1 -d ' ')
	link_count=$(wc -l links.txt | cut -f1 -d ' ')
	service_count=$(grep -E -o 'http:\/\/[[:alnum:]]{16,56}\.onion' links.txt | sort -u | wc -l)
	visited_service_count=$(grep -E -o 'http:\/\/[[:alnum:]]{16,56}\.onion' visited_links.txt | sort -u | wc -l)
	echo -e " we have visited $visited_link_count links and discovered $visited_service_count onion addresses, we still have $link_count unique links on $service_count hosts\n\r"
	service=$(grep -E -o 'http:\/\/[[:alnum:]]{16,56}\.onion.*' links.txt | sort -u | sort -R | head -n 1)
	link=$(grep "$service" links.txt | sort -R | head -n 1)
	if [ -z $link ]; then
		echo "no more links, we are done"
		exit 0
	fi
	echo -e "trying to get $link in run number $counter,\n\r"
	echo "$link" >> visited_links.txt
	sort -u visited_links.txt | sort > visited_links_new.txt && mv visited_links_new.txt visited_links.txt
	comm -23 links.txt visited_links.txt > links_new.txt && mv links_new.txt links.txt
	lynx -dump -listonly $link | grep -E 'http:\/\/[[:alnum:]]{16,56}\.onion.*' | grep -E -i -v '.*\.jpg$|.*\.gif$|.*\.png$|.*\.pdf$|.*\.mp3$|.*\.m3u$|.*\.avi$|.*\.jpeg$|.*\.bmp$|.*\.mkv$' | cut -f2- -d '.' | cut -c2- >> links.txt
done
